﻿using GrapeCity.Windows.SpreadSheet.Data;
using GrapeCity.Windows.SpreadSheet.UI;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfApplication95
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();

            DrawingObjectManager.SetDrawingObjectProvider(this.gcSpreadSheet1, new MyDrawingObjectProvider() { Spread = this.gcSpreadSheet1 }); 
        }
    }

    public class MyDrawingObjectProvider : IDrawingObjectProvider
    {
        public DrawingObject[] GetDrawingObjects(Worksheet sheet, int row, int column, int rowCount, int columnCount)
        {
            if (column == 0)
            {
                return new DrawingObject[] { new ButtonDrawingObject(row, column) { Spread = Spread } };
            }
            else if (column == 1)
            {
                return new DrawingObject[] { new CheckBoxDrawingObject(row, column) { Spread = Spread } };
            }

            return null;
        }
        public GcSpreadSheet Spread { get; set; }
    }

    public class ButtonDrawingObject : CustomDrawingObject
    {
        public ButtonDrawingObject(int anchorRow, int anchorColumn)
            : base(anchorRow, anchorColumn)
        {
            this.ShowDrawingObjectOnly = true;
        }

        public override FrameworkElement RootElement
        {
            get
            {
                Button btn = new Button();
                btn.IsHitTestVisible = false;
                btn.Content = this.Spread.ActiveSheet.GetText(AnchorRow, AnchorColumn);
                return btn;
            }
        }

        public GcSpreadSheet Spread { get; set; }
    }

    public class CheckBoxDrawingObject : CustomDrawingObject
    {
        public CheckBoxDrawingObject(int anchorRow, int anchorColumn)
            : base(anchorRow, anchorColumn)
        {
            this.ShowDrawingObjectOnly = true;
        }

        public override FrameworkElement RootElement
        {
            get { return new CheckBox(); }
        }

        public GcSpreadSheet Spread { get; set; }
    }

}
